---
title: Update DaVinci Flow
description: The PUT {{apiPath}}/v1/environments/{{envID}}/flows/{{flowID}} updates the flow specified by its ID in the request URL.
component: pingone-api
page_id: pingone-api:davinci:davinci-admin-apis/admin-flows/update-flow
canonical_url: https://developer.pingidentity.com/pingone-api/davinci/davinci-admin-apis/admin-flows/update-flow.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Update DaVinci Flow

##

```none
PUT {{apiPath}}/v1/environments/{{envID}}/flows/{{davinciFlowID}}
```

The `PUT {{apiPath}}/v1/environments/{{envID}}/flows/{{flowID}}` updates the flow specified by its ID in the request URL.

### Prerequisites

* Refer to [Create DaVinci Flow](create-flow.html) for important overview information.

> **Collapse: Request Model**
>
> | Property           | Type           | Required? |
> | ------------------ | -------------- | --------- |
> | `color`            | String         | Optional  |
> | `connectors`       | Array\[object] | Optional  |
> | `connectors.id`    | String         | Optional  |
> | `currentVersion`   | Integer        | Optional  |
> | `description`      | String         | Optional  |
> | `enabled`          | Boolean        | Optional  |
> | `graphData`        | Object         | Optional  |
> | `inputSchema`      | Array\[object] | Optional  |
> | `name`             | String         | Required  |
> | `outputSchema`     | Object         | Optional  |
> | `publishedVersion` | Integer        | Optional  |
> | `settings`         | Object         | Optional  |
> | `trigger`          | Object         | Optional  |
> | `trigger.type`     | String         | Optional  |
>
> Refer to [DaVinci Admin Flows](../admin-flows.html) for full property descriptions.

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "name": "DV-Flow_1713556322",
    "description": "Updated Description - modified via PUT Flow request",
    "enabled": true,
    "connectors": [
       { "id": "httpConnector" }
    ]
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff --request PUT '{{apiPath}}/v1/environments/{{envID}}/flows/{{davinciFlowID}}' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "name": "DV-Flow_1713556322",
    "description": "Updated Description - modified via PUT Flow request",
    "enabled": true,
    "connectors": [
       { "id": "httpConnector" }
    ]
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/flows/{{davinciFlowID}}")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Put);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""name"": ""DV-Flow_1713556322""," + "\n" +
@"    ""description"": ""Updated Description - modified via PUT Flow request""," + "\n" +
@"    ""enabled"": true," + "\n" +
@"    ""connectors"": [" + "\n" +
@"       { ""id"": ""httpConnector"" }" + "\n" +
@"    ]" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/flows/{{davinciFlowID}}"
  method := "PUT"

  payload := strings.NewReader(`{
    "name": "DV-Flow_1713556322",
    "description": "Updated Description - modified via PUT Flow request",
    "enabled": true,
    "connectors": [
       { "id": "httpConnector" }
    ]
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
PUT /v1/environments/{{envID}}/flows/{{davinciFlowID}} HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "name": "DV-Flow_1713556322",
    "description": "Updated Description - modified via PUT Flow request",
    "enabled": true,
    "connectors": [
       { "id": "httpConnector" }
    ]
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"name\": \"DV-Flow_1713556322\",\n    \"description\": \"Updated Description - modified via PUT Flow request\",\n    \"enabled\": true,\n    \"connectors\": [\n       { \"id\": \"httpConnector\" }\n    ]\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/flows/{{davinciFlowID}}")
  .method("PUT", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/flows/{{davinciFlowID}}",
  "method": "PUT",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "name": "DV-Flow_1713556322",
    "description": "Updated Description - modified via PUT Flow request",
    "enabled": true,
    "connectors": [
      {
        "id": "httpConnector"
      }
    ]
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'PUT',
  'url': '{{apiPath}}/v1/environments/{{envID}}/flows/{{davinciFlowID}}',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "name": "DV-Flow_1713556322",
    "description": "Updated Description - modified via PUT Flow request",
    "enabled": true,
    "connectors": [
      {
        "id": "httpConnector"
      }
    ]
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/flows/{{davinciFlowID}}"

payload = json.dumps({
  "name": "DV-Flow_1713556322",
  "description": "Updated Description - modified via PUT Flow request",
  "enabled": True,
  "connectors": [
    {
      "id": "httpConnector"
    }
  ]
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("PUT", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/flows/{{davinciFlowID}}');
$request->setMethod(HTTP_Request2::METHOD_PUT);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "name": "DV-Flow_1713556322",\n    "description": "Updated Description - modified via PUT Flow request",\n    "enabled": true,\n    "connectors": [\n       { "id": "httpConnector" }\n    ]\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/flows/{{davinciFlowID}}")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Put.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "name": "DV-Flow_1713556322",
  "description": "Updated Description - modified via PUT Flow request",
  "enabled": true,
  "connectors": [
    {
      "id": "httpConnector"
    }
  ]
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"name\": \"DV-Flow_1713556322\",\n    \"description\": \"Updated Description - modified via PUT Flow request\",\n    \"enabled\": true,\n    \"connectors\": [\n       { \"id\": \"httpConnector\" }\n    ]\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/flows/{{davinciFlowID}}")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "PUT"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

200 OK

```json
{
    "_links": {
        "environment": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        },
        "connectorInstances": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/connectorInstances"
        },
        "flow.deploy": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/flows/a79d1931573009379f0691befa538d97"
        },
        "flow.clone": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/flows/a79d1931573009379f0691befa538d97"
        },
        "flow.enabled": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/flows/a79d1931573009379f0691befa538d97/enabled"
        },
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/flows/a79d1931573009379f0691befa538d97"
        }
    },
    "id": "a79d1931573009379f0691befa538d97",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "name": "DV-Flow_1713556322",
    "description": "Updated Description - modified via PUT Flow request",
    "enabled": true,
    "currentVersion": 4,
    "createdAt": "2024-04-19T19:52:02.666Z",
    "updatedAt": "2024-04-19T22:32:51.353Z"
}
```
